%define ia32el_subdirname ia32el_6687_6635

Summary: IA-32 Execution Layer
Name: ia32el
Version: 1.6
Release: 15%{?dist}
License: LGPL, Commercial
Group: Applications/Emulators
Source:  ia32el_6687.6635.tgz
Source2: ia32el
Source3: is_ia32el.c
Source4: is_ia32el.EL5
Source5: auxapp
Source6: ia32el-v6-docs.tar.bz2
Patch0: ia32el-build.patch
Buildroot: %{_tmppath}/%{name}-root
Prereq: /sbin/chkconfig
ExclusiveArch: ia64

# libia32x.so unfortunately pokes into ld.so internals
Requires: glibc >= 2.3.4
BuildRequires: libgcj-devel

%define _filter_GLIBC_PRIVATE 1

%description
This package contains IA-32 Execution Layer platform which allows emulation
of IA-32 binaries on IA-64.

%prep
# -n `ia32el' would overwrite ia32el script for local build
%setup -n ia32el-build -c
tar xvvjf ${RPM_SOURCE_DIR}/ia32el-v6-docs.tar.bz2
cd %{ia32el_subdirname}/src
%patch0 -p3

%build
make -C %{ia32el_subdirname}/src %{?_smp_mflags}
make -C %{ia32el_subdirname}/src/MTL/mme %{?_smp_mflags}

%install
mkdir -p %{buildroot}/etc/rc.d/init.d %{buildroot}%{_libdir}/ia32el %{buildroot}/lib %{buildroot}%{_includedir}

# == this was built on ia32 ==
# `make -C src/MTL/auxapp/'
# mode 644 so that rpmbuild won't get confused by this file when
# deducing dependencies
install -m 644 %{SOURCE5} %{buildroot}%{_libdir}/ia32el/auxapp
# `gcc -O2 -static -nostdlib -o is_ia32el.EL5 is_ia32el.c'
# don't install with the EL5 suffix
# mode 644: avoid stripping, stripping i386 binary on ia64 currently damages it
install -m 644 %{SOURCE4} %{buildroot}%{_libdir}/ia32el/is_ia32el
# == predistributed stuff ==
install -m 755 %{SOURCE2} %{buildroot}/etc/rc.d/init.d/ia32el
install -m 644 %{ia32el_subdirname}/ia32exec.bin %{buildroot}%{_libdir}/ia32el/
# == built here ==
install -m 755 %{ia32el_subdirname}/src/ia32x/bin.release/libia32x.so %{buildroot}%{_libdir}/ia32el/
install -m 755 %{ia32el_subdirname}/src/loader/bin.release/ia32x_loader %{buildroot}%{_libdir}/ia32el/
install -m 755 %{ia32el_subdirname}/src/loader/bin.release/suid_ia32x_loader %{buildroot}%{_libdir}/ia32el/
install -m 755 %{ia32el_subdirname}/src/MTL/mme/bin.release/libmme.so %{buildroot}%{_libdir}/
# == header file for libmme developers ==
install -m 755 %{ia32el_subdirname}/src/MTL/mme/mme_jvm_api.h  %{buildroot}%{_includedir}/

%post
/sbin/chkconfig --add ia32el
if [ $1 = 1 ]; then
	%{_libdir}/ia32el/is_ia32el > /dev/null 2>&1
	case $? in [01]) ;;
		   *) /sbin/service ia32el start > /dev/null 2>&1;;
	esac
elif [ $1 -gt 1 ]; then
	/sbin/service ia32el condrestart >/dev/null 2>&1 || :
fi

%preun
if [ $1 = 0 ]; then
    /sbin/service ia32el stop > /dev/null 2>&1
    /sbin/chkconfig --del ia32el
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING COPYING.LIBC EULA
%config /etc/rc.d/init.d/ia32el
%dir %{_libdir}/ia32el
%{_libdir}/ia32el/libia32x.so
%attr(755,root,root) %{_libdir}/ia32el/auxapp
%{_libdir}/ia32el/ia32x_loader
%{_libdir}/ia32el/ia32exec.bin
%attr(755,root,root) %{_libdir}/ia32el/is_ia32el
%{_libdir}/libmme.so
%attr(4555,root,root) %{_libdir}/ia32el/suid_ia32x_loader

#%files devel
%{_includedir}/mme_jvm_api.h

%changelog
* Mon Jul  9 2007 Petr Machata <pmachata@redhat.com> - 1.6-15
- Intel drop ia32el-1.6: 6687.6635 (V6U1)
- Resolves: #244953

* Tue Sep 12 2006 Petr Machata <pmachata@redhat.com> - 1.6-14
- restarting ia32el in postun (bz 206117)
- spec hack to disallow rpm inferring dependencies based on auxapp
- remove ld-linux.so.2 symlink
- fix dist tag

* Tue Aug 15 2006 Petr Machata <pmachata@redhat.com> - 1.6-13
- Intel patch 6100 (IT99847)
  - When handling memory permission changes, IA-32 EL currently uses
    number of native page instead of IA-32 page, which cause Matlab
    failed on IA-32 EL.
  - Change signal handling for mixed-mode execution
  - Force sysv hash table for btlib binary because btlib loader
    (ia32x_loader) cannot handle DT_GNU_HASH (default in RHEL 5
    linker) currently.

* Mon Aug 14 2006 Petr Machata <pmachata@redhat.com> - 1.6-12
- use %dist tag in revision

* Fri Aug 11 2006 Petr Machata <pmachata@redhat.com> - 1.6-11.EL5
- #201763:
  - force linker to produce libia32x with traditional SysV hash
  - rename is_ia32el to is_ia32el.EL5 to prevent collisions
  - don't strip is_ia32el

* Tue Jul 18 2006 Petr Machata <pmachata@redhat.com> - 1.6-10.EL5
- execshield protection of auxapp

* Fri Jun 23 2006 Petr Machata <pmachata@redhat.com> - 1.6-9.1.EL5
- Intel drop ia32el-1.6: 6096.6515
- Intel patch 6097: IA-32 EL may wrongly set an internal flag
  which can cause performance degradation.
- Intel patch 6098: waitpid problem (#195715)

* Fri Jun 16 2006 Petr Machata <pmachata@redhat.com> 1.3-2.7
- adding patch that fixes naming of certain gcc builtins
- turning off -Werror, all reported warnings are harmless

* Fri Jun 16 2006 Petr Machata <pmachata@redhat.com> 1.3-2.1
- bump up release for 5E-extras rebuild

* Wed Nov 16 2005 Jakub Jelinek <jakub@redhat.com> 1.3-2
- updated to 5.3.110.45.24 (#170475, IT#75975, IT#76977)
  - honor core_pattern properly when creating core files
    (#143769, IT#66088)
  - fix sendmsg and recvmsg (#164236)
- updated to ia32exec.bin 5352

* Wed Jul 20 2005 Jakub Jelinek <jakub@redhat.com> 1.2-5
- updated to 5.3.102.39.23 (#157234)
  - altroot script fix when the script couldn't be opened
  - handle stack expansion if needed when creating signal
    frame
  - __lll_mutex_unlock sync before atomic op instead of after it

* Wed May  4 2005 Jakub Jelinek <jakub@redhat.com> 1.2-4
- updated to 5338 version of ia32exec.bin

* Mon Feb 14 2005 Jakub Jelinek <jakub@redhat.com> 1.2-3
- updated to 5.3.98.37.22
  - handle SG_IO ioctl (#145695)
  - /proc/self/stat fix

* Mon Feb  7 2005 Jakub Jelinek <jakub@redhat.com> 1.2-2
- remove dependency on exact glibc versions (#145400)
- update to 5337 version of ia32exec.bin
- updated to 5.3.96.36.22 (#145390)
  - LSB test fixes
    - use tkill instead of kill in cancellation_signal
    - check membership of secondary groups in check_exec_permissions
    - check_exec_permissions should use euid not ruid
  - core file name uses core_pattern (#143769)
  - values in /proc/self/stat converted to IA-32 values - fix to
    IBM-JVM failure
  - fixes to execve-script patch

* Thu Jan  6 2005 Jakub Jelinek <jakub@redhat.com> 1.1-20
- reenable script-execve patch
- bump BUILD_NO's in it

* Tue Dec 21 2004 Jakub Jelinek <jakub@redhat.com> 1.1-19
- disable script-execve patch for now

* Mon Dec 20 2004 Jakub Jelinek <jakub@redhat.com> 1.1-18
- don't conflict with glibc 2.3.4

* Sat Dec 18 2004 Jakub Jelinek <jakub@redhat.com> 1.1-17
- some more fixes to the script hack

* Fri Dec 17 2004 Jakub Jelinek <jakub@redhat.com> 1.1-16
- minor improvements for the last hack

* Fri Dec 17 2004 Jakub Jelinek <jakub@redhat.com> 1.1-15
- add hack for execve syscall, so that when 32-bit app
  tries to execute #! script or no-magic /bin/sh script
  and the corresponding interpreter is also present in
  /emul/ia32-linux, it uses that interpreter (#133822)

* Wed Dec  8 2004 Jakub Jelinek <jakub@redhat.com> 1.1-14
- update to 5.3.88.34.22 (identical to what was in 1.1-13:
  5.3.88.34.22 is 5.3.79.29.20 plus 9 patches 1.1-13 was
  applying)

* Mon Dec  6 2004 Jakub Jelinek <jakub@redhat.com> 1.1-13
- start ia32el service in %%post automatically if no other
  way of running IA-32 binaries works and the package is
  installed for the first time (rather than upgraded; #141973)

* Mon Dec  6 2004 Jakub Jelinek <jakub@redhat.com> 1.1-12
- fix emulation of acct (#141407)
- handle 64k kernel page size (#141416)
- security fixes backported from kernel's binfmt_elf.c (#139830)
- 32-bit core dump fixes (#139806, #139815)

* Thu Nov 18 2004 Jakub Jelinek <jakub@redhat.com> 1.1-11
- new noaltroot patch
  - /emul/ia32-linux prefix also interpreter lookup (#133822)
- remove ld-linux.so.2 symlink

* Tue Nov 16 2004 Jakub Jelinek <jakub@redhat.com> 1.1-10
- start ia32el earlier and shut down later (#139428)
- don't use -Winline (#138433)

* Mon Nov  8 2004 Jakub Jelinek <jakub@redhat.com> 1.1-9
- fix mmap64 (#138345)

* Tue Nov  2 2004 Jakub Jelinek <jakub@redhat.com> 1.1-8
- allow executing non-readable 32-bit binaries (#137855)

* Fri Oct 22 2004 Jakub Jelinek <jakub@redhat.com> 1.1-7
- updated noaltroot patch to fix execve

* Thu Oct 21 2004 Jakub Jelinek <jakub@redhat.com> 1.1-6
- added /lib/ld-linux.so.2 symlink

* Wed Oct 20 2004 Jakub Jelinek <jakub@redhat.com> 1.1-5
- update to latest source drop from Intel
- fix stat64 (#136140)
- handle /emul/ia32-linux without kernel support

* Tue Oct  5 2004 Jakub Jelinek <jakub@redhat.com> 1.1-4
- update to 5336 version of ia32exec.bin
- make is_ia32el statically linked
- drop dependency on libc.so.6 and ld-linux.so.2,
  so that ia32el can be installed before installing all
  32-bit rpms

* Tue Sep 28 2004 Jakub Jelinek <jakub@redhat.com> 1.1-3
- update to 5335 version of ia32exec.bin
- added Intel's EULA for ia32exec.bin
- adjust glibc requires/conflicts for RHEL4

* Sat Sep 25 2004 Jakub Jelinek <jakub@redhat.com> 1.1-2
- rebuilt

* Fri Sep 24 2004 Jakub Jelinek <jakub@redhat.com> 1.1-1
- new upstream release

* Tue Aug 31 2004 Jakub Jelinek <jakub@redhat.com> 1.0-5
- change Requires from /emul/ia32-linux/lib/{ld-linux.so.2,libc.so.6}
  which rpm apparently doesn't handle to {ld-linux.so.2,libc.so.6}
  that is provided only by the glibc-2*.i?86.rpm packages, but not
  *.ia64.rpm packages

* Tue Jun 22 2004 Jakub Jelinek <jakub@redhat.com> 1.0-4
- bump BUILD_NO in the makefile to 4608
- affinity fixes (#123340)
- fast syscall fix (#123341)
- environ size checks (#123343)
- handle large argv[0] (#126483)
- fix error reporting if suid loader can't be executed (#126484)
- fix buffer overflow (#126485)
- disallow executing suid binaries with read but no execute permissions
  for user (#126486)

* Thu Mar 25 2004 Jakub Jelinek <jakub@redhat.com> 1.0-3
- fix {,f}statfs (#118963)

* Thu Mar 11 2004 Jakub Jelinek <jakub@redhat.com> 1.0-2
- fix up License tag
- add licenses to %%doc

* Tue Feb 24 2004 Jakub Jelinek <jakub@redhat.com> 1.0-1
- initial package
